#include <pthread.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdlib.h>
#include <errno.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>

#define MAXBUFSIZE 100


void *process_request(void *arg)
{
  char buf[MAXBUFSIZE];
  int num, fd;

  /* sleep(3); */
  
  fd = *((int *) arg);
  pthread_detach(pthread_self());

  while ((num = read(fd, buf, MAXBUFSIZE))) 
  {
    if (num > 0) 
      write(fd, buf, num);

    printf("Request handled by thread %lu\n", (unsigned long) pthread_self()); 
    /* sleep(1); */
  }

  close(fd);
  return NULL;
}


int main(int argc, char * argv[])
{
  int sockfd, rec_sock;
  struct sockaddr_in addr;
  pthread_t tid;
      
  if (argc < 2) 
  {
    fprintf(stderr,"USAGE: %s port.\n", argv[0]);
    exit(-1);
  }

  if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) 
  {
    perror("socket");
    exit(1);
  }

  memset(&addr, 0, sizeof(struct sockaddr_in));
  addr.sin_addr.s_addr = htonl(INADDR_ANY);
  addr.sin_family = AF_INET;
  addr.sin_port = htons(atoi(argv[1]));

  if (bind(sockfd, (struct sockaddr *)&addr, sizeof(addr)) < 0) 
  {
    perror("bind");
    exit(1);
  }

  
  if (listen(sockfd, 5) < 0) 
  {
    perror("listen");
    exit(1);
  }

  for(;;)
  {
    if( (rec_sock = accept(sockfd, NULL, NULL)) < 0)
    {
      if (errno == EINTR)
	continue;
      else 
      {
	perror("accept");
	exit(1);
      }
    }
    
    switch(pthread_create(&tid, NULL, process_request, &rec_sock)) /* Dangerous! */
    {
    case 0:
      break;
    case ENOMEM:  
      fprintf(stderr, "Thread creation failed: ENOMEM\n");
      break;
    case EINVAL:
      fprintf(stderr, "Thread creation failed: EINVAL\n");
      break;
     case EPERM:
      fprintf(stderr, "Thread creation failed: EPERM\n");
      break;
    default: 
      fprintf(stderr, "Thread creation failed: Unknown error\n");
    }	

  }

  return 0;
}


